<template>
  <nav>
    <router-link to="/">Home</router-link>
    <aside>
      <search-component />
      <div v-if="getUpdatedList">
        <div class="box-card" v-for="user in getUpdatedList" :key="user.id.value">
          <router-link :to="`/search/user/${user.id.value}`">
            <div class="user-preview">
              <div>
                <img class="user-preview__photo" :src="user.picture.thumbnail" alt="">
              </div>
              <div class="user-preview__info cut-text">
                <div>
                  <span v-if="user.name">{{ user.name.title}}</span>
                  <span v-if="user.name" class="pl-1">{{ user.name.first}}</span>
                  <span v-if="user.name" class="pl-1">{{ user.name.last}}</span>
                </div>
                <div>{{user.email }}</div>
              </div>
            </div>
          </router-link>
        </div>
      </div>
      <el-button type="primary" @click="loadMoreUsers" class="w-100">Load More</el-button>
    </aside>
  </nav>
</template>

<script>
  import {mapState, mapGetters} from "vuex";
  import SearchComponent from '../components/Search.component';
  
  export default {
    name: "SideNavigation",
    components: {
      SearchComponent
    },
    data () {
      return {
        actualList: []
      }
    },
    computed: {
      ...mapState('users', ['page']),
      ...mapGetters('users', ['getSortedUsers']),
      getUpdatedList () {
        return this.getSortedUsers()
      }
    },
    methods: {
      loadMoreUsers() {
        const payload = {
          page: this.page + 1,
          results: 25
        };
        console.log('loadMoreUsers')
        this.$store.dispatch('users/getUsersList', payload)
      }
    }
  }
</script>

<style lang="scss">
  .user-preview {
    display: flex;
    &__photo {
      width: 70px;
    }
    &__info {
      padding-left: 20px;
    }
  }

</style>
